﻿/* define cometmarks globalData const variables */
if( typeof( CometMarksLogDefine ) == "undefined" )
{
	try
	{
		eval('																						\r\n\
			const CometMarksLogDefine =																\r\n\
			{																						\r\n\
				logFileName				:	"cometmarks.log"										\r\n\
			};																						\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

var cometmarks = Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension);

////////////////////////////////////
// about log file
function write_log( data )
{
	var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);      
	var prefs = ps.getBranch( "cometmarks." );
	var enable_logs = prefs.getBoolPref( "enable_logs" );
   	
	if ( !enable_logs )
		return;
 
	// 0x02 | 0x10 to open file for appending.
	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var file = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('ProfD', Components.interfaces.nsIFile);
	file.append( CometMarksLogDefine.logFileName );
	if ( !file.exists() )
	{
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666 )
	}
	
	 // begin to write log into file
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	foStream.init( file, 0x02 | 0x10, 0666, 0 ); 

	var now_time = CometMarksUtility.formatGmtTime( new Date());
	data = "[" + now_time + "] " + data + "\r";
	foStream.write( data, data.length );
	foStream.close();
}

function delete_log()
{
	var file = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('ProfD', Components.interfaces.nsIFile);
	file.append( CometMarksLogDefine.logFileName );
  
	if ( file.exists() )
		file.remove(true);
}

function cometmarks_show_logs()
{
	try
	{		
		var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var file = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('ProfD', Components.interfaces.nsIFile);
		file.append( CometMarksLogDefine.logFileName );
		var uri = ios.newFileURI(file);
		CometMarksUtility.openURL( uri.spec );
	}
	catch (e)
	{
		write_log(e);
	}
}